# is it possible with maximum travel distance "dist" to ensure
# the distance between points is "mindist"?
def check(pts, dist, mindist):
    # prev: the place the previous point in the loop was moved to,
    # initially the triage station location
    prev = 0

    # move each point to the leftmost possible point
    # if this is more than "dist" units to the right then it is impossible
    for x in pts:

        # check if moving x as far right as possible still is not far enough
        if prev + mindist > x + dist:
            return False

        # we can move x up to "dist" units to the left, but it must
        # also be "dist" units to the right of the previous point
        prev = max(prev+mindist, x-dist)

    return True


n, d = map(int, input().split())
pts = list(map(int, input().split()))

if check(pts, 0, d):
    print("0.0")
else:
    # invariant: throughout the algorithm it is impossible
    # using distance 'lo' but it is possible using distance 'hi'
    lo, hi = 0, 2**30

    while hi-lo > 0.0000001:
        # try the midpoint
        mid = (lo+hi)*0.5
        if check(pts, mid, d):
            hi = mid
        else:
            lo = mid

    # now lo and hi are so close we just use hi as the answer
    print("{0:0.1f}".format(hi))

    #fun exercise!
    # show that the true (unrounded) answer x is such that 2*x is an integer
