# m is a dictionary where m[v] is the number of die that are showing value v
# returns the score of this roll
def solve(m):
    rep = max(m.values()) # the maximum ``X of a kind'' value X

    run = 0 # the maximum run length, computed in the first loop below

    # for each starting value, compute the longest run possible
    # starting with that value
    for i in range(1,7):
        tr = 0
        while i in m: # we can extend the sequence
            i += 1
            tr += 1
        run = max(run, tr)

    if rep == 5: return 100

    if rep == 4: return 80

    if run == 5: return 70

    # if there is a full house then one value appears twice and another three times
    if set(m.values()) == {2,3}: return 60

    if run == 4: return 50

    if rep == 3: return 40

    if run == 3: return 30

    # explanation, if there are two pairs then there are three distinct values
    # conversely, if there are three distinct values the either one appears 3 times
    # or two appear twice, but we already checked if one appears 3 times
    if len(m) == 3: return 25

    # no rule applies, just add the values
    tot = 0
    for x in m:
        tot += x*m[x]
    return tot



d = int(input())

for i in range(d):
    r = list(map(int, input().split()))

    # build the dictionary for the solve() function
    m = {}
    for x in r:
        if x not in m: m[x] = 1
        else: m[x] += 1

    print(solve(m))
