# can we climb to the top in T seconds using staming s = "guess"?
def climb(h, r, T, guess):
    # tot = total time so far
    # rem = remaining stamina (as we simulate the climb)
    # at = the last ledge we reached
    tot, rem, at = 0, mid, 0

    # idea, climb as far as possible and rest only when we
    # can't reach the next ledge
    while at < n and tot <= T:
        delta = h[at+1] - h[at] # distance to next ledge

        # check if our guess can't even reach the next ledge with full stamina
        if delta > guess: return False

        # if we can't make the next ledge with our remaining stamina, rest
        if delta > rem:
            rem = guess # resting refills our stamina
            tot += r    # but it takes r seconds to rest
        else:
            at += 1      # we reached the next ledge
            tot += delta # but it depleted our stamina by delta
            rem -= delta # and we spent delta seconds doing it

    # check if we reached the top on time
    return tot <= T

n, r, T = map(int, input().split())
h = [0]+list(map(int, input().split()))

# invariant: we can't do it with s = lo, we can with s = hi
lo, hi = 0, T
while lo+1 < hi:
    mid = (lo+hi)//2
    if climb(h, r, T, mid):
        hi = mid
    else:
        lo = mid

# the invariant promises we can't with s = lo, we can with s = hi,
# but termination of the loop guarantees lo+1 = hi, so s = hi is the minimum
# stamina to climb the mountain in at most T seconds

print(hi)
