# perform a depth-first search from node v but do not go along the edge
# to node par (it was the parent of v in this search)

# returns 0 if we need to double edge (v, par) to satisfy v's parity requirement
# otherwise returns 1
def dfs(v, par):
    # use tot and the list of doubled edges that are in the the global scope
    global tot, e

    # get the parity requirement for v, note p[] is also global but we don't modify it so we don't have to declare it as such
    b = p[v]

    for w, c in g[v]: # for each edge touching v
        if w == par: continue;
        # perform the search from node w and see if (w,v) needs to be doubled
        if dfs(w, v) == 0:
            # if we had to double (w,v), add it to the cost and the set of edges to output
            tot += c
            e.append((min(v,w), max(v,w)))
        else:
            # otherwise, conceptually removing w and the edge (v,w) will flip
            # the parity requirement of v
            b ^= 1

    # if b has parity requirement 0, we must double (v, par)
    return b

n = int(input())
p = list(map(int, input().split()))

# g is a list of lists, for a node u, g[u] will be a list of all edges touching i
# and this edge will be stored as (v,c) (the other endpoint and the cost)
g = [[] for i in range(n)]
for i in range(n-1):
    u, v, c = map(int, input().split())
    g[u].append((v,c))
    g[v].append((u,c))

e = []
tot = 0

# if reducing the problem to a single vertex had its reduced parity requirement 0
# then it all worked!
if dfs(0, -1) == 0:
    e.sort() # will sort them lexicographically
    print(tot, len(e))
    for f in e: print(*f)
else:
    print("impossible")
